//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.usability.evaluation.rule.set;

import java.util.EnumSet;

import org.apache.commons.lang.StringUtils;

import com.google.common.base.Optional;

import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTree;
import de.ugoe.cs.autoquest.usability.evaluation.result.UsabilityDefect;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Alexander Deicke
 */
public class EmptyUsabilityRuleset implements UsabilityRuleset {

    private enum EmptyUsabilityRule implements UsabilityRule {
        ;

        @Override
        public Optional<UsabilityDefect> evaluate(ITaskTree taskTree) {
            return Optional.absent();
        }

        @Override
        public String ruleIdentifier() {
            return StringUtils.EMPTY;
        }

    }

    private final EnumSet<EmptyUsabilityRule> EMPTY_USABILITY_RULESET = EnumSet
        .noneOf(EmptyUsabilityRule.class);

    @Override
    public EnumSet<? extends UsabilityRule> evaluationRules() {
        return EMPTY_USABILITY_RULESET;
    }

}
